import Coder from '../src';

import marketAbi from './abi/market.json';
import wethAbi from './abi/weth.json';

const wethCoder = new Coder(wethAbi);
const marketCoder = new Coder(marketAbi);

const withdrawalEvent = wethCoder.encodeEvent('Withdrawal', {
  src: '0x8939b49a0983a9e6ef416c23ccd8b04af0e8a006',
  wad: '500000000000000000',
});
console.log(withdrawalEvent);

const updateMarketsCall = marketCoder.encodeFunction('updateMarkets', {
  goods: [
    [
      {
        seller: '0x3DCa2eCBBfadbCbf83CfD456E1657A52E170CbF3',
        name: 'Apple',
        price: 35,
      },
      {
        seller: '0x3DCa2eCBBfadbCbf83CfD456E1657A52E170CbF3',
        name: 'Pear',
        price: 32,
      },
    ],
    [
      {
        seller: '0x1f56BfF579f7a57326d07823a00A7fF0e57CBb4f',
        name: 'Paper',
        price: 120,
      },
      {
        seller: '0x1f56BfF579f7a57326d07823a00A7fF0e57CBb4f',
        name: 'Pen',
        price: 50,
      },
      {
        seller: '0x1f56BfF579f7a57326d07823a00A7fF0e57CBb4f',
        name: 'Staples',
        price: 8,
      },
    ],
  ],
});
console.log(updateMarketsCall);

const addSellerCall = marketCoder.encodeFunction('addSeller', {
  seller: {
    name: 'Mark',
    team: {
      team: '0x00192Fb10dF37c9FB26829eb2CC623cd1BF599E8',
      name: 'Blue',
      id: 13,
    },
  },
});
console.log(addSellerCall);
